VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CommonDlgsW"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
'Common Dialogs: Color, Open/Save File without the CommonDialog OCX.
'
'No dependencies.
'

Private Const CC_ANYCOLOR = &H100
Private Const CC_RGBINIT = &H1
Private Const CC_FULLOPEN = &H2

Private Type CHOOSECOLOR
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As Long
    Flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Declare Function ChooseColorAPI Lib "comdlg32" Alias "ChooseColorW" ( _
    ByRef CHOOSECOLOR As CHOOSECOLOR) As Long

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Public Enum FileOpenConstants
    'ShowOpen, ShowSave constants.
    cdlOFNAllowMultiselect = &H200&
    cdlOFNCreatePrompt = &H2000&
    cdlOFNExplorer = &H80000
    cdlOFNExtensionDifferent = &H400&
    cdlOFNFileMustExist = &H1000&
    cdlOFNHideReadOnly = &H4&
    cdlOFNLongNames = &H200000
    cdlOFNNoChangeDir = &H8&
    cdlOFNNoDereferenceLinks = &H100000
    cdlOFNNoLongNames = &H40000
    cdlOFNNoReadOnlyReturn = &H8000&
    cdlOFNNoValidate = &H100&
    cdlOFNOverwritePrompt = &H2&
    cdlOFNPathMustExist = &H800&
    cdlOFNReadOnly = &H1&
    cdlOFNShareAware = &H4000&
End Enum
'Case-preserving hack:
#If False Then
    Dim cdlOFNAllowMultiselect, cdlOFNCreatePrompt, cdlOFNExplorer, cdlOFNExtensionDifferent
    Dim cdlOFNFileMustExist, cdlOFNHideReadOnly, cdlOFNLongNames, cdlOFNNoChangeDir
    Dim cdlOFNNoDereferenceLinks, cdlOFNNoLongNames, cdlOFNNoReadOnlyReturn
    Dim cdlOFNNoValidate, cdlOFNOverwritePrompt, cdlOFNPathMustExist, cdlOFNReadOnly
    Dim cdlOFNShareAware
#End If

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As Long
    lpstrCustomFilter As Long
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As Long
    nMaxFile As Long
    lpstrFileTitle As Long
    nMaxFileTitle As Long
    lpstrInitialDir As Long
    lpstrTitle As Long
    Flags As FileOpenConstants
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
End Type

Private Declare Function GetOpenFileName Lib "comdlg32" Alias "GetOpenFileNameW" ( _
    ByRef OPENFILENAME As OPENFILENAME) As Long

Private Declare Function GetSaveFileName Lib "comdlg32" Alias "GetSaveFileNameW" ( _
    ByRef OPENFILENAME As OPENFILENAME) As Long

Private CHOOSECOLOR As CHOOSECOLOR
Private CustomColors(0 To 15) As Long 'Buffer to retain user's settings.

Private OPENFILENAME As OPENFILENAME
Private strFilter As String
Private strFile As String
Private strFileTitle As String
Private strInitialDir As String
Private strTitle As String
Private strDefExt As String

Private mColor As Long

'Shared properties, used with multiple dialog types.
Public Flags As FileOpenConstants

'ShowOpen, ShowSave properties.
Public DefaultExt As String 'Value excludes period.
Public DialogTitle As String
Public FileName As String
Public FileTitle As String
Public Filter As String
Public FilterIndex As Long
Public InitDir As String
Public MaxFileSize As Long

'ShowColor property.
Public Property Get Color() As OLE_COLOR
    Color = mColor
End Property

Public Property Let Color(ByVal RHS As OLE_COLOR)
    If RHS And &H80000000 Then
        mColor = GetSysColor(RHS And &HFFFF&)
    Else
        mColor = RHS
    End If
End Property

Public Function ShowColor(ByVal hWnd As Long) As Boolean
    'Returns False on Cancel or error.
    With CHOOSECOLOR
        .lStructSize = LenB(CHOOSECOLOR)
        .hwndOwner = hWnd
        .Flags = CC_ANYCOLOR Or CC_RGBINIT Or CC_FULLOPEN
        .lpCustColors = VarPtr(CustomColors(0))
        .rgbResult = mColor
    End With
    ShowColor = ChooseColorAPI(CHOOSECOLOR) <> 0
    If ShowColor Then mColor = CHOOSECOLOR.rgbResult
End Function

Public Function ShowOpen(ByVal hWnd As Long) As Boolean
    'Returns False on Cancel or error.
    InitOPENFILENAME hWnd
    ShowOpen = GetOpenFileName(OPENFILENAME) <> 0
    If ShowOpen Then ExtractOpenFile
End Function

Public Function ShowSave(ByVal hWnd As Long) As Boolean
    'Returns False on Cancel or error.
    InitOPENFILENAME hWnd
    ShowSave = GetSaveFileName(OPENFILENAME) <> 0
    If ShowSave Then ExtractOpenFile
End Function

Private Sub InitOPENFILENAME(ByVal hWnd As Long)
    With OPENFILENAME
        .lStructSize = LenB(OPENFILENAME)
        .hwndOwner = hWnd
        strFilter = Replace$(Filter, "|", vbNullChar) & vbNullChar
        .lpstrFilter = StrPtr(strFilter)
        .lpstrCustomFilter = 0
        .nFilterIndex = FilterIndex
        strFile = FileName & String$(256 - Len(FileName), 0)
        .lpstrFile = StrPtr(strFile)
        .nMaxFile = MaxFileSize
        strFileTitle = String$(256, 0)
        .lpstrFileTitle = StrPtr(strFileTitle)
        .nMaxFileTitle = 256
        strInitialDir = InitDir & String$(256 - Len(InitDir), 0)
        .lpstrInitialDir = StrPtr(strInitialDir)
        strTitle = DialogTitle
        .lpstrTitle = StrPtr(strTitle)
        .Flags = Flags
        strDefExt = DefaultExt
        .lpstrDefExt = StrPtr(strDefExt)
        .lpTemplateName = 0
    End With
End Sub

Private Sub ExtractOpenFile()
    Dim NulPos As Long
    
    With OPENFILENAME
        FileName = strFile
        FileTitle = ""
        If (Flags And cdlOFNAllowMultiselect) = 0 Then
            NulPos = InStr(FileName, vbNullChar)
            If NulPos < 1 Then NulPos = Len(FileName) + 1
            FileName = Left$(FileName, NulPos - 1)
            If (Flags And cdlOFNNoValidate) = 0 Then
                NulPos = InStr(strFileTitle, vbNullChar)
                If NulPos < 1 Then NulPos = Len(strFileTitle) + 1
                FileTitle = Left$(strFileTitle, NulPos - 1)
            End If
        End If
        Flags = .Flags
    End With
End Sub

Private Sub Class_Initialize()
    Color = &HC0C0C0
    Filter = "All files (*.*)|*.*"
    FilterIndex = 1
    MaxFileSize = 256
End Sub
