VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Masker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Private Const REDUCTION_THRESHOLD As Integer = &H220 'Max value &H2FD.

Private imgfOrig As WIA.ImageFile
Private imgfFlat As WIA.ImageFile 'This is loaded with a second copy of the original image
                                  'right after it gets loaded into imgfOrig.  After this
                                  'it will be the result of calls to Flatten.
Private imgfComposed As WIA.ImageFile
Private imgpCompose As WIA.ImageProcess
Private imgpFlatten As WIA.ImageProcess
Private imgpConvertToPng As WIA.ImageProcess
Private Vector As WIA.Vector 'This will be left hanging around so we can use it to
                             'obtain most recently composed image's pixel colors.
Private colKnocks As Collection 'Each Item is Array(PixelIndex, NewARGB, OrigARGB).
Private ReductionMask As Long

Private mComposed As StdPicture
Private mDepth As Integer
Private mHeight As Long
Private mIsAlpha As Boolean
Private mLoaded As Boolean
Private mMaskColor As Long
Private mPaintColor As Long
Private mReduction As Integer
Private mWidth As Long

Public AlphaThreshold As Byte

Public Property Get Composed() As StdPicture
    Set Composed = mComposed
End Property

Public Property Get Depth() As Integer
    Depth = mDepth
End Property

Public Property Get Height() As Long
    Height = mHeight 'Pixels.
End Property

Public Property Get IsAlpha() As Boolean
    IsAlpha = mIsAlpha
End Property

Public Property Get Loaded() As Boolean
    Loaded = mLoaded
End Property

Public Property Get MaskColor() As OLE_COLOR
    MaskColor = mMaskColor
End Property

Public Property Let MaskColor(ByVal RHS As OLE_COLOR)
    If RHS And &H80000000 Then
        mMaskColor = GetSysColor(RHS And &HFFFF&)
    Else
        mMaskColor = RHS
    End If
End Property

Public Property Get PaintColor() As OLE_COLOR
    PaintColor = mPaintColor
End Property

Public Property Let PaintColor(ByVal RHS As OLE_COLOR)
    If RHS And &H80000000 Then
        mPaintColor = GetSysColor(RHS And &HFFFF&)
    Else
        mPaintColor = RHS
    End If
End Property

Public Property Get Reduction() As Integer
    Reduction = mReduction
End Property

Public Property Let Reduction(ByVal RHS As Integer)
    If 0 > RHS Or RHS > 5 Then Err.Raise 380 'Invalid property value.
    
    mReduction = RHS
    ReductionMask = Choose(mReduction + 1, 0&, &H10101, &H30303, &H70707, &HF0F0F, &H1F1F1F)
End Property

Public Property Get Width() As Long
    Width = mWidth 'Pixels.
End Property

Public Sub AddKnock(ByVal PX As Long, ByVal PY As Long, ByVal NewRGB As Long)
    Dim PixelIndex As Long
    Dim NewARGB As Long
    
    PixelIndex = PY * mWidth + PX + 1
    Set Vector = imgfComposed.ARGBData
    NewARGB = &HFF000000 _
           Or (NewRGB \ &H10000) _
           Or (NewRGB And &HFF00&) _
           Or ((NewRGB And &HFF&) * &H10000)
    colKnocks.Add Array(PixelIndex, NewARGB, Vector.Item(PixelIndex))
    Vector.Item(PixelIndex) = NewARGB
    With imgpFlatten
        Set .Filters(1).Properties("ARGBData").Value = Vector
        Set imgfComposed = .Apply(imgfComposed)
    End With
    Set mComposed = imgfComposed.FileData.Picture
End Sub

Public Sub Apply()
    If mIsAlpha Then Flatten
    Compose
End Sub

Public Function IsKnocked(ByVal PX As Long, ByVal PY As Long) As Boolean
    Dim PixelIndex As Long
    Dim Knock As Variant
    
    PixelIndex = PY * mWidth + PX + 1
    For Each Knock In colKnocks
        If Knock(0) = PixelIndex Then
            IsKnocked = True
            Exit Function
        End If
    Next
End Function

Public Sub LoadFile(ByRef FileName As String)
    With imgfOrig
        .LoadFile FileName
        mWidth = .Width
        mHeight = .Height
        mDepth = .PixelDepth
        mIsAlpha = .IsAlphaPixelFormat
    End With
    imgfFlat.LoadFile FileName 'Initially a faithful copy, easiest to just load again here.
    Set colKnocks = New Collection
    mLoaded = True
End Sub

Public Function PixelRGB(ByVal PX As Long, ByVal PY As Long) As Long
    Dim ARGB As Long

    ARGB = Vector.Item(PY * mWidth + PX + 1)
    PixelRGB = ((ARGB And &HFF&) * &H10000) _
            Or (ARGB And &HFF00&) _
            Or ((ARGB And &HFF0000) \ &H10000)
End Function

Public Sub RemoveKnock(ByVal PX As Long, ByVal PY As Long)
    Dim PixelIndex As Long
    Dim I As Long
    Dim Knock As Variant
    
    PixelIndex = PY * mWidth + PX + 1
    With colKnocks
        For I = 1 To .Count
            Knock = .Item(I)
            If Knock(0) = PixelIndex Then
                Set Vector = imgfComposed.ARGBData
                Vector.Item(PixelIndex) = Knock(2)
                With imgpFlatten
                    Set .Filters(1).Properties("ARGBData").Value = Vector
                    Set imgfComposed = .Apply(imgfComposed)
                End With
                Set mComposed = imgfComposed.FileData.Picture
                .Remove I
                Exit Sub
            End If
        Next
    End With
End Sub

Public Sub SaveFile(ByVal FileName As String, Optional ByVal AsBmp As Boolean = False)
    If Not AsBmp Then
        With imgpConvertToPng
            Set imgfComposed = .Apply(imgfComposed)
        End With
    End If
    imgfComposed.SaveFile FileName
End Sub

Private Sub Compose()
    Dim BackdropBits() As Byte
    Dim R As Byte
    Dim G As Byte
    Dim B As Byte
    Dim y As Long
    Dim x As Long
    Dim I As Long
    Dim Vector As WIA.Vector
    
    ReDim BackdropBits(((mWidth * 3& + 3&) \ 4&) * 4& * mHeight - 1&)
    R = MaskColor And &HFF
    G = (MaskColor \ &H100) And &HFF
    B = MaskColor \ &H10000
    For y = 0 To mHeight - 1
        For x = 0 To mWidth - 1
            I = y * (((mWidth * 3& + 3&) \ 4&) * 4&) + x * 3
            BackdropBits(I) = B
            BackdropBits(I + 1) = G
            BackdropBits(I + 2) = R
        Next
    Next
    Set Vector = New WIA.Vector
    Vector.BinaryData = BackdropBits
    With imgpCompose
        Set .Filters(1).Properties.Item("ImageFile").Value = imgfFlat
        Set imgfComposed = .Apply(Vector.ImageFile(mWidth, mHeight))
    End With
    Set mComposed = imgfComposed.FileData.Picture
End Sub

Private Sub Flatten()
    'If Threshold = 0 a "full alpha" copy is done, else:
    '
    '   o  The alpha of each pixel is clamped according to Threshold: either
    '      transparent or fully opaque
    '   o  If colKnocks contains a list of pixels to "knock out" by setting then
    '      to mask or paint colors this is done.
    '   o  If the Reduction > 0 a crude color-reduction is applied to each
    '      non-maskcolor pixel.
    Dim I As Long
    Dim ARGB As Long
    Dim Alpha As Byte
    Dim Brightness As Integer
    Dim Knock As Variant
    
    Set Vector = imgfOrig.ARGBData
    If AlphaThreshold <> 0 Then
        With Vector
            'This is something that WIA is slow at since Item access to a Vector
            'leaves something to be desired in terms of speed:
            For I = 1 To .Count
                ARGB = .Item(I)
                Alpha = (ARGB And &H7F000000) \ &H1000000
                If ARGB < 0 Then Alpha = Alpha Or &H80
                If Alpha < AlphaThreshold Then
                    .Item(I) = 0
                Else
                    ARGB = ARGB Or &HFF000000
                    If mReduction > 0 Then
                        Brightness = (ARGB And &HFF0000) \ &H10000 _
                                   + (ARGB And &HFF00&) \ &H100 _
                                   + (ARGB And &HFF&)
                        If Brightness > REDUCTION_THRESHOLD Then
                            'Bright pixels "reduce upward."
                            ARGB = ARGB Or ReductionMask
                        Else
                            'Dimmer pixels "reduce downward."
                            ARGB = ARGB And Not ReductionMask
                        End If
                    End If
                    .Item(I) = ARGB
                End If
            Next
            For Each Knock In colKnocks
                .Item(Knock(0)) = Knock(1)
            Next
        End With
    End If
    With imgpFlatten
        Set .Filters(1).Properties("ARGBData").Value = Vector
        Set imgfFlat = .Apply(imgfOrig)
    End With
End Sub

Private Sub Class_Initialize()
    Set imgfOrig = New WIA.ImageFile
    Set imgfFlat = New WIA.ImageFile
    Set imgpFlatten = New WIA.ImageProcess
    With imgpFlatten
        .Filters.Add .FilterInfos.Item("ARGB").FilterID
    End With
    Set imgpCompose = New WIA.ImageProcess
    With imgpCompose
        .Filters.Add .FilterInfos.Item("Stamp").FilterID
        With .Filters(1).Properties
            .Item("Left").Value = 0
            .Item("Top").Value = 0
        End With
    End With
    Set imgpConvertToPng = New WIA.ImageProcess
    With imgpConvertToPng
        .Filters.Add .FilterInfos.Item("Convert").FilterID
        .Filters(1).Properties.Item("FormatID").Value = wiaFormatPNG
    End With
    MaskColor = &HC0C0C0
    PaintColor = vbBlack
End Sub
